package handler

import (
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"

	"github.com/gin-gonic/gin"
	"github.com/sirupsen/logrus"
)

func WrapCreateProductHandler(ctx *gin.Context) {
	handler := newCreateProductHandler(ctx)
	baseRun(handler)
}

func newCreateProductHandler(ctx *gin.Context) *CreateProductHandler {
	return &CreateProductHandler{
		req:  http_model.NewCreateProductRequest(),
		resp: http_model.NewCreateProductResponse(),
		ctx:  ctx,
	}
}

type CreateProductHandler struct {
	req  *http_model.CreateProductRequest
	resp *http_model.CommonResponse
	ctx  *gin.Context
}

func (h *CreateProductHandler) getRequest() interface{} {
	return h.req
}
func (h *CreateProductHandler) getContext() *gin.Context {
	return h.ctx
}
func (h *CreateProductHandler) getResponse() interface{} {
	return h.resp
}
func (h *CreateProductHandler) run() {
	data := http_model.CreateProductRequest{}
	data = *h.req
	res, err := service.Product.CreateProduct(h.ctx, data)
	if err != nil {
		logrus.Errorf("[CreateProductHandler] call CreateProduct err:%+v\n", err)
		util.HandlerPackErrorResp(h.resp, consts.ErrorInternal)
		return
	}
	h.resp.Data = res
}
func (h *CreateProductHandler) checkParam() error {
	return nil
}
